<?php

/*******************************************
*                                         *
*     Filmverwaltung mit PHP & MySQL      *
*                                         *
*******************************************
*                                         *
* Copyright: ab 2005 Dominik Erdmann      *
*  Internet: www.der-domi.de              *
*     Email: kontakt@der-domi.de          *
*                                         *
*******************************************
*                                         *
* Das Skript darf nach eigenem Belieben   *
* gendert werden. Copyright-Hinweise und *
* Links auf www.der-domi.de drfen nicht  *
* verndert werden und mssen jederzeit   *
* sichtbar bleiben!                       *
*                                         *
*******************************************
*/

/*
* class for import
* 
* Copyright-Hinweis:
* Vorlage des Quellcodes ist das Import-Addon von Sebastian Arndt.
* siehe: http://www.der-domi.de/board/viewtopic.php?t=11
* siehe: tools/import-addon_by_sebastian_arndt.tar.gz
*/

  class import {
  
  var $importTypes;       // include all possible databases
  var $importDB;          // include the online-database
  var $importID;          // ID which can imported from database
  var $varToImport;       // all variables which can be imported
  
  var $searchResult;
  
  var $url;
  var $buf1;
  var $buf2;
  var $buf3;
  var $siteBuf;
  var $loadBuf;
  
  
  function import() {
  
    $this->importTypes = array( "OFDB", "IMDB" );
    //$this->importTypes = array( "IMDB", "OFDB" ); // replace this line with above: set IMDB as default
    if ( array_key_exists( 'importDB', $_GET ) )
      $this->importType = $_GET['importDB'];
    
    $this->searchResult = array();
    $this->varToImport = array();
  }
  
  /*
  * search for a given string in OFDB
  * save all results in array
  */
  function ofdbsearch() {
  
    if ( !strlen($_GET["searchText"]) )
      return -1;
    
    // url to get search result
    $this->url = $this->getLinkToDB( urlencode(utf8_encode($_GET["searchText"])), FALSE, TRUE );
    
    if ( loadFile( $this->url, $this->buf1, "r" ) >= 0 ) {
    
      $this->buf2 = explode( "</i><br><br>1.", $this->buf1 );
      $this->buf1 = $this->buf2[1];
      $this->buf2 = explode( "<br><br><br>", $this->buf1 );
      $this->buf1 = $this->buf2[0];
      $this->buf2 = explode( "<a href=\"film/", $this->buf1 );
      
      for ( $i=0; $i<count($this->buf2) && $i<25; ++$i ) {
      
        $pattern = "#[0-9]*\.\s<a href=\"film/|\"\sonmouseover.*\)\">|<font size=\"1\">\ /\s|</font>\s\(|\)</a>#";
        $this->buf1 = preg_split ($pattern, trim ($this->buf2[$i]), -1, PREG_SPLIT_NO_EMPTY );
        
        $this->searchResult[$i] = array();
        $this->searchResult[$i]['title'] =  utf8_decode( $this->buf1[1] );
        $this->searchResult[$i]['id'] =  substr(utf8_decode ( $this->buf1[0] ),0,strpos(utf8_decode ( $this->buf1[0] ),','));
        $this->searchResult[$i]['year'] =  $this->buf1[3];
      
      if ( $this->buf1[2] != $this->buf1[1] )
        $this->searchResult[$i]['alt'] =  utf8_decode ( $this->buf1[2] );
      else
        $this->searchResult[$i]['alt'] =  "";
      }
      array_shift($this->searchResult); 
    }
  }
  
  /*
  * search for a given string in OFDB
  * save all results in array
  */
  function ofdbsearchEAN() {
    if ( !strlen($_GET["searchEANText"]) )
      return -1;
      
    // url to get search result
    $this->url = $this->getLinkToDB( urlencode(utf8_encode($_GET["searchEANText"])), FALSE, TRUE ,'EAN');
    
    if ( loadFile( $this->url, $this->buf1, "r" ) >= 0 ) {
      $this->buf2 = explode( "</b><br><br>1.", $this->buf1 );
      $this->buf1 = $this->buf2[1];
      $this->buf2 = explode( "<br><br><br>", $this->buf1 );
      $this->buf1 = $this->buf2[0];
      $this->buf2 = explode( "<a href=\"film/", $this->buf1 );
      
      for ( $i=0; $i<count($this->buf2) && $i<25; ++$i ) {
        $pattern = "#[0-9]*\.\s<a href=\"film/|\"\sonmouseover.*;>',SHADOW,true\)\"><b>|\)<\/b><\/a><br>|&vid=|\"\sonmouseover.*;>',SHADOW,true\)\">|<\/a>#";
        $this->buf1 = preg_split ($pattern, trim ($this->buf2[$i]), -1, PREG_SPLIT_NO_EMPTY );
        list ($title, $year) = explode( ' (', $this->buf1[1] );
        $this->searchResult[$i] = array();
        $this->searchResult[$i]['title'] =  $title;
        $this->searchResult[$i]['id'] =  substr(utf8_decode ( $this->buf1[0] ),0,strpos(utf8_decode ( $this->buf1[0] ),','));
        $this->searchResult[$i]['year'] =  $year;
        $this->searchResult[$i]['fid'] = $this->buf1[3];
        $this->searchResult[$i]['ftitle'] = $this->buf1[4];
      }
      array_shift($this->searchResult); 
    }
  }
  
  /*
  * search for a given string in IMDB
  * save all results in array
  */
  function imdbsearch() {        
    if ( !strlen($_GET["searchText"]) )
      return -1;
    
    // url to get search result
    $this->url = $this->getLinkToDB( urlencode($_GET["searchText"]."*"), FALSE, TRUE );
    
    if ( loadFile( $this->url, $this->buf1, "r" ) >= 0 ) {
      $this->buf1 = str_replace( "<b>Images from&nbsp;<a href=\"/title/", "", $this->buf1 );
      $this->buf2 = explode( 'src=\'/rg/find-title-', $this->buf1 );
      $this->buf1 = ""; // clear temporary buffer
      
      // get all movie-informations for all results
      // ignore first element becase this doesn't include results
      for ( $i=1; $i<count($this->buf2); ++$i ) {
        /* trim result */ 
        // get position of </td></tr>
        $needle = "</td></tr>";
        $pos = strpos($this->buf2[$i], $needle);
        // delete $needle and follow string
        $this->buf2[$i] = substr( $this->buf2[$i], 0, $pos );                
        
        // find delimiter - get id
        $pattern = '\?link=\/title\/|' .
        // find delimiter - get titel
                   '(\/\';">&#x22;|\/\';">)|' .
        // find delimiter - get year
                   '(&#x22;<\/a> \(|<\/a> \()|' .
        // find delimiter - get alternative title
                   '(<p class="find-aka">Auch bekannt als: "|<p class="find-aka">Auch bekannt als: &#x22;)|' .
        // find delimiter - get country
                   '("&nbsp;- |&#x22;&nbsp;- |" - )|' .
        // find delimiter - get end
                    '<em>';                  
        
        // format pattern string
        $pattern = "/" . $pattern . "/";
        $string_array = preg_split ($pattern, trim ($this->buf2[$i]), -1, PREG_SPLIT_NO_EMPTY );
              
        // Leere Eintrge aus Suchergebniss ignorieren
        if (empty($string_array) == 0) {
          array_shift($string_array);
          
          // fill results
          $this->searchResult[$i-1] = array();
          $this->searchResult[$i-1]['title'] =  trim($string_array[1]);
          $this->searchResult[$i-1]['id'] =  trim($string_array[0]);
          $this->searchResult[$i-1]['year'] =  substr(trim($string_array[2]),0,stripos(trim($string_array[2]),')'));
          
          if ( count($string_array) >= 6 ) {
            // if alternativ name longer than 70 letter, there is an error
            if ( strlen($string_array[3]) < 70 ) {
              $this->searchResult[$i-1]['alt'] =  trim($string_array[3]);
              //$this->searchResult[$i-1]['alt'] .=  " - ".trim($string_array[4]); // country
            }
          } else
            $this->searchResult[$i-1]['alt'] =  "";
        }
      }
    }
  }
  
  function ofdbimport( &$myVar) {
  
    if ( !strlen($_GET["importID"]) )
      return -1;
    
    $this->importID = $_GET['importID'];
    $this->FassungID = $_GET['fassungID'];
    
    // url to get search result
    $this->url = ret_entities( $this->getLinkToDB( $this->importID ) );
    
    if ( loadFile( $this->url, $this->siteBuf, "r" ) >= 0 ) {
      
      // Titel
      $search = "<h2><font face=\"Arial,Helvetica,sans-serif\" size=\"3\"><b>";
      $this->buf1 = explode( $search, $this->siteBuf );
      $this->buf2 = explode( '</b></font></h2></td>', $this->buf1[1] );
      $this->varToImport['title'] = htmlentities( utf8_decode( $this->buf2[0] ) );
      
      // url
      $this->varToImport['url'] = htmlentities( $this->url );
      
      // Originaltitel
      $search = '<td width="99%"><font face="Arial,Helvetica,sans-serif" size="2" class="Daten"><b>';
      $this->buf1 = explode( $search, $this->siteBuf );
      $this->buf2 = explode( '</b></font></td>', $this->buf1[1] );
      $this->varToImport['original_title'] = htmlentities( utf8_decode ($this->buf2[0] ) );
      
      // Land
      $search = '<a href="view.php?page=blaettern&Kat=Land&Text=';
      $this->buf1 = explode( $search, $this->siteBuf );
      $this->varToImport['land'] = array();
      for ( $i=1; $i<count($this->buf1); ++$i ) {
        $this->buf2 = explode( '"', $this->buf1[$i] );
        $this->varToImport['land'][$i-1] = htmlentities( utf8_decode (urldecode ($this->buf2[0] ) ) );
      }
      
      // Jahr
      $search = '<a href="view.php?page=blaettern&Kat=Jahr&Text=';
      $this->buf1 = explode( $search, $this->siteBuf );
      $this->buf2 = explode( '"', $this->buf1[1] );
      $this->varToImport['year'] = $this->buf2[0];
      
      // Genres
      $search = '<a href="view.php?page=genre&Genre=';
      $this->buf1 = explode( $search, $this->siteBuf );
      $this->varToImport['genres'] = array();
      for ( $i=1; $i<count($this->buf1); ++$i ) {    
        $this->buf2 = explode( '"', $this->buf1[$i] );
        $this->varToImport['genres'][$i-1] = htmlentities( utf8_decode (urldecode( $this->buf2[0] ) ) );
      }
      
      // Cover
      $search = 'http://img.ofdb.de/film/';
      $this->buf1 = explode( $search, $this->siteBuf );
      $this->buf2 = explode( '"', $this->buf1[1] );
      if ( $this->buf2[0] != "na.gif" )
        $this->varToImport['cover'] = "http://img.ofdb.de/film/".$this->buf2[0];
      
      // Versionen (Fassungen)
      $search = '<a href="view.php?page=fassung&fid='.$this->importID.'&vid=';
      $this->buf1 = explode( $search, $this->siteBuf );
      $this->varToImport['versions'] = array();
      $var = $myVar->getRequest("");
      for ( $i=1; $i<count($this->buf1); ++$i ) { 
        $this->buf2 = explode( '">', $this->buf1[$i] );
        $this->varToImport['versions'][$i-1] = array();
        $this->varToImport['versions'][$i-1]['Importlink'] = $_SERVER['PHP_SELF']."?".$var . 'importDB='.$this->importType.'&amp;importID='.$this->importID.'&amp;fassungID='.$this->buf2[0];
        $this->varToImport['versions'][$i-1]['Fassungslink'] = "http://www.ofdb.de/view.php?page=fassung&amp;fid=".$this->importID."&amp;vid=".$this->buf2[0];
        $this->varToImport['versions'][$i-1]['FassungsID'] = $this->buf2[0];
        
        $this->buf2 = explode( '</a></b>', $this->buf2[1] );
        $this->varToImport['versions'][$i-1]['name'] = htmlentities( utf8_decode (urldecode( $this->buf2[0] ) ) );
      }
      
      // FSK
      $search = "Freigabe: ";
      $this->buf1 = explode( $search, $this->siteBuf );
      $this->buf2 = explode( '"', $this->buf1[1] );
      list ($textFsk, $fsk, $rest) = explode( ' ', $this->buf2[0] );
      
      if ($textFsk == "FSK") {
        if ($fsk == "o.A.")
            $this->varToImport['fsk'] = "0";
          else if ($fsk == "Keine")
            $this->varToImport['fsk'] = "18";
          else if (is_numeric ($fsk))
            $this->varToImport['fsk'] = $fsk;
          else 
            $this->varToImport['fsk'] = "";		// error!
      } elseif ($textFsk == "SPIO/JK:") {
        if ($fsk == "keine")
          $this->varToImport['fsk'] = "18";
        else
          $this->varToImport['fsk'] = "";
      } else	// FSK unbekannt
        $this->varToImport['fsk'] = "";
      
      // Inhalt
      $search = '<a href="plot/';
      $this->buf1 = explode( $search, $this->siteBuf );
      $this->buf2 = explode( '">', $this->buf1[1] );
  
      $this->url = "http://www.ofdb.de/plot/".$this->buf2[0];
      if ( $this->buf2[0] && loadFile( $this->url, $this->loadBuf, "r" ) >= 0 ) {    
        $search = '</b><br><br>';
        $this->buf1 = explode( $search, $this->loadBuf );
        $this->buf2 = explode( '</font></p>', $this->buf1[1] );
        $this->varToImport['inhalt'] = utf8_decode($this->buf2[0]);
      }
      
      
      // url to get search result (detail)
      $this->url = "http://www.ofdb.de/view.php?page=film_detail&fid=$this->importID";
      
      if ( loadFile( $this->url, $this->loadBuf, "r" ) >= 0 ) {
        // Schauspieler
        $search = "<b><i>Darsteller</i></b>";
        $this->buf1 = explode( $search, $this->loadBuf );
        $this->buf2 = explode( "</table>", $this->buf1[1] );
        $search = "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\">";
        $this->buf1 = explode( $search, $this->buf2[0] );
        
        $search = "<tr valign=\"middle\">";
        $this->buf2 = explode( $search, $this->buf1[1] );
        for ( $i=1; $i<count($this->buf2); ++$i ) {
          $this->buf1 = explode( "&nbsp;&nbsp;", strip_tags( $this->buf2[$i] ) );
          $this->varToImport['actors'][$i-1] =  htmlentities( utf8_decode ( trim( $this->buf1[1] ) ) ) ;
        }
        
        // Regisseure
        $search = "<b><i>Regie</i></b>";
        $this->buf1 = explode( $search, $this->loadBuf );
        $this->buf2 = explode( "</table>", $this->buf1[1] );
        $search = "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\">";
        $this->buf1 = explode( $search, $this->buf2[0] );
        
        $search = "<tr valign=\"middle\">";
        $this->buf2 = explode( $search, $this->buf1[1] );
        for ( $i=1; $i<count($this->buf2); ++$i ) {
          $this->buf1 = explode( "&nbsp;&nbsp;", strip_tags( $this->buf2[$i] ) );
          $this->varToImport['regisseure'][$i-1] = htmlentities( utf8_decode ( trim( $this->buf1[1] ) ) );
        }
      }
    }
    
    if($this->FassungID) {
      $this->url = 'http://www.ofdb.de/view.php?page=fassung&fid='.$this->importID.'&vid='.$this->FassungID;
      
      if ( loadFile( $this->url, $this->siteBuf, "r" ) >= 0 ) {
        
        // FassungsLink
        $this->varToImport['furl'] = $this->url;
        
        // Bildformat
        $search = "Bildformat:</font></td><td></td><td><font size=\"2\" face=\"Arial, Helvetica, sans-serif\" class=\"Daten\"><b>";
        $this->buf1 = explode( $search, $this->siteBuf );
        $this->buf2 = explode( '</b></font></td></tr>', $this->buf1[1] );
        
        $this->buf3 = explode( '(', $this->buf2[0] );
        $this->varToImport['Bildformat'] = trim(utf8_decode($this->buf3[0]));
        $this->varToImport['Aufloesung'] = str_replace(')','',utf8_decode($this->buf3[1]));
        if($this->varToImport['Aufloesung'] == 'anamorph / 16:9') 
          $this->varToImport['Aufloesung'] = '576p';
        
        
        // Untertitel
        $search = "Untertitel:</font></td><td></td><td><font size=\"2\" face=\"Arial, Helvetica, sans-serif\" class=\"Daten\"><b>";
        $this->buf1 = explode( $search, $this->siteBuf );
        $this->buf2 = explode( '</b></font></td></tr>', $this->buf1[1] );
        $this->buf3 = explode( '<br>', $this->buf2[0] );
        for ( $i=0; $i<count($this->buf3); ++$i ) {
          if (strpos($this->buf3[$i],'</b>') === FALSE) {
          $this->varToImport['Untertitel'][$i] = html_entity_decode($this->buf3[$i]);
          }
        }
        
        // Tonformat
        $search = "Tonformat:</font></td><td></td><td><font size=\"2\" face=\"Arial, Helvetica, sans-serif\" class=\"Daten\"><b>";
        $this->buf1 = explode( $search, $this->siteBuf );
        $this->buf2 = explode( '</a><br></b></font></td></tr>', $this->buf1[1] );
        $this->buf3 = explode( '">', $this->buf2[0] );                       
        for ( $i=1; $i<count($this->buf3); ++$i ) {
          $this->buf1 = explode( ')', $this->buf3[$i] );
          $this->buf2 = explode( '(', $this->buf1[0] );
          $this->varToImport['Sprache'][$i-1] = utf8_decode($this->buf2[0]);            
          $this->varToImport['Tonformat'][$i-1] = utf8_decode($this->buf2[1]);
        }
        
        // Laufzeit einlesen
        $search = "Laufzeit:</font></td><td></td><td><font size=\"2\" face=\"Arial, Helvetica, sans-serif\" class=\"Daten\"><b>";
        $this->buf1 = explode( $search, $this->siteBuf );
        $this->buf2 = explode( '</b></font></td></tr>', $this->buf1[1] );
        list ($min, $sek, $rest) = explode( ':', $this->buf2[0] );
        list ($sek, $rest, $rest2) = explode( ' Min', $sek );
        
        if($sek > 30) {
          $min = $min +1;
        }
        $this->varToImport['Laufzeit'] = $min;
        
        // EAN einlesen
        $search = "EAN/UPC</a>:</font></td><td></td><td><font size=\"2\" face=\"Arial, Helvetica, sans-serif\" class=\"Daten\"><b>";
        $this->buf1 = explode( $search, $this->siteBuf );
        $this->buf2 = explode( '</b>', $this->buf1[1] );
        $this->varToImport['EAN'] = utf8_decode( $this->buf2[0] );
        
        // Format - wenn kein Logo vorhanden
        $search = "Erscheinungsart:</font></td><td>&nbsp;&nbsp;&nbsp;</td><td width=\"99%\"><font size=\"2\" face=\"Arial, Helvetica, sans-serif\" class=\"Daten\"><b>";
        $this->buf1 = explode( $search, $this->siteBuf );
        $this->buf2 = explode( '</b></font><br>', $this->buf1[1] );
        $this->varToImport['Format'] = utf8_decode( $this->buf2[0] );
        
        // Format - wenn Logo vorhanden
        if(empty($this->buf2[0])) {
          $search = ">Erscheinungsart:</font></td><td>&nbsp;&nbsp;&nbsp;</td><td width=\"99%\"><img src=\"";
          $this->buf1 = explode( $search, $this->siteBuf );
          $this->buf1 = explode( "<font size=\"1\" face=\"Arial, Helvetica, sans-serif\" style=\"font-size: 10px; vertical-align: top;\">&nbsp;&nbsp;&nbsp;" ,$this->buf1[1]);
          $this->buf2 = explode( '</font><br><img ', $this->buf1[1] );
          $this->varToImport['Format'] = utf8_decode( $this->buf2[0] );
        }
          
        // FSK - bereits erkannte FSK freigabe sichern
        $fsk = $this->varToImport['fsk'];
        
        // nun erst nach Freigabe ohne FSK suchen
        $search = ")\">SPIO/JK: ";
        $this->buf1 = explode( $search, $this->siteBuf );
        $this->buf2 = explode( '</a></b></font></td></tr>', $this->buf1[1] );
        
        if($this->buf2[0] == "keine schwere Jugendgef&auml;hrdung") {
          $this->varToImport['fsk'] = 18;  
        } else {
          
          // Nichts gefunden, dann normale FSK freigabe suchen
          $search = ")\">FSK ";
          $this->buf1 = explode( $search, $this->siteBuf );
          $this->buf2 = explode( '</a></b></font></td></tr>', $this->buf1[1] );
          
          if ($this->buf2[0] == "o.A.")
            $this->varToImport['fsk'] = "0";
          else if ($this->buf2[0] == "Keine Jugendfreigabe")
            $this->varToImport['fsk'] = "18";
          else if (is_numeric ($this->buf2[0]))
            $this->varToImport['fsk'] = $this->buf2[0];
          else 
            $this->varToImport['fsk'] = "$fsk";		// error!
        }
      }
    }
  }
  
  function imdbimport( &$myVar ) {
    
    if ( !strlen($_GET["importID"]) )
      return -1;
    
    $this->importID = $_GET['importID'];
    
    // url to get search result
    $this->url = ret_entities( $this->getLinkToDB( $this->importID ) );
    
    if ( loadFile( $this->url, $this->siteBuf, "r" ) >= 0 ) {
      
      // Titel
      $search = "<h1>";
      $this->buf1 = explode( $search, $this->siteBuf );
      $this->buf2 = explode( ' <span>', $this->buf1[1] );
      $this->varToImport['title'] = $this->buf2[0];
      
      // Originaltitel
      $search = "<h1>";
      $this->buf1 = explode( $search, $this->siteBuf );
      $this->buf2 = explode( ' <span>', $this->buf1[1] );
      $this->varToImport['original_title'] = $this->buf2[0];
      
      // url
      $this->varToImport['url'] = $this->url;
      
      // Jahr
      $search = '<a href="/">IMDb</a>';
      $this->buf1 = explode( $search, $this->siteBuf );
      
      $this->buf2 = explode( '(', $this->buf1[1] );
      $this->buf1 = explode( ')', $this->buf2[1] );
      $this->varToImport['year'] = $this->buf1[0];
      
      // Land
      $search = '<h5>Land:</h5><div class="info-content">';
      $this->buf1 = explode( $search, $this->siteBuf );
      $this->buf2 = explode( '</div>', $this->buf1[1] );
      $search = ' | ';
      $this->buf1 = explode( $search, $this->buf2[0] );
      $this->varToImport['land'] = array();
      for ( $i=0; $i<count($this->buf1); ++$i )
      {
        $this->varToImport['land'][$i] = urldecode( $this->buf1[$i] );
      }
      
      // Laufzeit
      $search = "<h5>L&#xE4;nge:</h5><div class=\"info-content\">";
      $this->buf1 = explode( $search, $this->siteBuf );
      $this->buf2 = explode( ' Min', $this->buf1[1] );
      $this->varToImport['Laufzeit'] = $this->buf2[0];
      
      // Bildformat
      $search = "<h5>Seitenverh&#xE4;ltnis:</h5><div class=\"info-content\">";
      $this->buf1 = explode( $search, $this->siteBuf );
      $this->buf2 = explode( " <a class=\"tn15mo", $this->buf1[1] );
      $this->varToImport['Bildformat'] = str_replace(' ', '',$this->buf2[0]);             
      
      // FSK
      $search = "Bundesrepublik Deutschland:";
      $this->buf1 = explode( $search, $this->siteBuf );
      $this->buf2 = explode( '  |', $this->buf1[1] );
      $this->varToImport['fsk'] = $this->buf2[0];
      
      // Cover
      $search = '<div class="photo">';
      $this->buf1 = explode( $search, $this->siteBuf );
      $this->buf2 = explode( '</div>', $this->buf1[1] );
      $search = 'src="';
      $this->buf1 = explode( $search, $this->buf2[0] );
      $this->varToImport['cover'] = array();
      for ( $i=1; $i<count($this->buf1); ++$i )
      {
        $this->buf2 = explode( '" />', $this->buf1[$i] );
        $this->buf2[0] = substr($this->buf2[0],0,stripos($this->buf2[0],'._V1') + 4) . '_.jpg';
        $this->varToImport['cover'][$i-1] = urldecode( $this->buf2[0] );
      }
      
      // Genres
      $search = "<h5>Genre:</h5>\n<div class=\"info-content\">\n";
      $this->buf1 = explode( $search, $this->siteBuf );
      $this->buf2 = explode ("\n", $this->buf1[1]);
      $this->buf1 = explode( ' | ', $this->buf2[0] );
      $this->varToImport['genres'] = array();
      for ( $i=0; $i<count($this->buf1); ++$i ) {                            
        $this->varToImport['genres'][] = urldecode( $this->buf1[$i] );
      }
      
      // Regisseure
      $search = 'src=\'/rg/directorlist/position';
      $this->buf1 = explode( $search, $this->siteBuf );
      for ( $i=1; $i<count($this->buf1); ++$i ) {
        // format pattern string
        $pattern = "/" . '\/\';">|(<\/a><\/td>|<\/a>)' . "/";
        $string_array = preg_split ($pattern, trim ($this->buf1[$i]), -1, PREG_SPLIT_NO_EMPTY );
        $this->varToImport['regisseure'][] = $string_array[1];
      }
      
      // Actors
      $search = 'src=\'/rg/castlist/position';
      $this->buf1 = explode( $search, $this->siteBuf );    
      for ( $i=1; $i<count($this->buf1); ++$i ) {
        // format pattern string
        $pattern = "/" . '\/\';">|(<\/a><\/td>|<\/a>)' . "/";
        $string_array = preg_split ($pattern, trim ($this->buf1[$i]), -1, PREG_SPLIT_NO_EMPTY );
        $this->varToImport['actors'][] = $string_array[1];
      }
      
      // Inhalt
      $this->url = $this->url . "plotsummary";
      if ( loadFile( $this->url, $this->siteBuf, "r" ) >= 0 ) {
        $search = "<div id=\"swiki.2.1\">\n\n";
        $this->buf1 = explode( $search, $this->siteBuf );
        $this->buf2 = explode( "\n\n</div>", $this->buf1[1]);
        $this->varToImport['inhalt'] = "";
        $this->buf2[0] = strip_tags($this->buf2[0],'');
        $this->varToImport['inhalt'] = htmlentities( urldecode( $this->buf2[0] ) );
      }
    }
  }
  
  
  function getData( $data ) {
    if ( array_key_exists( $data, $this->varToImport ) ) {
      if ( !is_array( $this->varToImport[$data] ) )
        return $this->varToImport[$data];
      
      $ret = "";
      
      for ( $i=0; $i<count($this->varToImport[$data]); $i++ ) {
        if ( $i != 0 )
          $ret .= ", ";
        
        if ( $data != "versions" )
          $ret .= trim( $this->varToImport[$data][$i] );
        else
          $ret .= "<a href=\"{$this->varToImport[$data][$i]['Importlink']}\">{$this->varToImport[$data][$i]['name']}</a><a href=\"{$this->varToImport[$data][$i]['Fassungslink']}\" target=\"_blank\"> - (OFDB: {$this->varToImport[$data][$i]['FassungsID']})</a>";
      }
      return $ret;
    } else
      return "";
  }
  
  
  function printSearchResult(&$myVar) {
    
    $var = $myVar->getRequest(""); 
    
    echo "<ul>";
    for ( $i=0; $i<count($this->searchResult); ++$i ) {
      
      echo "<li>";
      $link = $_SERVER['PHP_SELF']."?".$var . "importDB=$this->importType&amp;importID={$this->searchResult[$i]['id']}";
      echo "(" . $this->searchResult[$i]['year']. ") <a href=\"$link\">" .$this->searchResult[$i]['title'] . "</a>";
      
      if ( strlen($this->searchResult[$i]['alt']) )
        echo " (alternativ: ".$this->searchResult[$i]['alt'].")";
      
      echo $this->getLinkToDB( $this->searchResult[$i]['id'], TRUE );
      echo "</li>";
      
      if ($this->searchResult[$i]['ftitle']) {
        echo "<ul>";
        echo '<li>';     
        $link = $_SERVER['PHP_SELF']."?".$var . "importDB=$this->importType&amp;importID={$this->searchResult[$i]['id']}&amp;fassungID={$this->searchResult[$i]['fid']}";
        echo " Fassung: <a href=\"$link\">" .$this->searchResult[$i]['ftitle'] . "</a>";
        echo $this->getLinkToDB( $this->searchResult[$i]['id'], TRUE, FALSE, $this->searchResult[$i]['fid']  );
        echo '</li>';
        echo "</ul>";
      }
    }
    echo "</ul>";
  }
  
  function getLinkToDB( $id, $asHyperref=FALSE, $search=FALSE, $cat='Titel' ) {
    if ( FALSE==$search ) {
      if ( $this->importTypes[$this->importType] == "OFDB" ) {
        $link = "http://www.ofdb.de/view.php?page=film&fid=$id";
        if($cat != 'Titel') { $link .= '&vid=' . $cat; }
      } elseif ( $this->importTypes[$this->importType] == "OFDB_XML") 
        $link = "http://xml.n4rf.net/ofdbgw/movie/$id";
      else
        $link = "http://german.imdb.com/title/$id/";
    } else { // get link to search
      if ( $this->importTypes[$this->importType] == "OFDB" )
        $link = "http://www.ofdb.de/view.php?page=suchergebnis&SText=" . $id . "&Kat=".$cat;
      elseif ( $this->importTypes[$this->importType] == "OFDB_XML")
        $link = 'http://xml.n4rf.net/ofdbgw/search_ext/'. urlencode(utf8_encode($id)).'.xml';
      else
        $link = "http://german.imdb.com/find?q=" . $id . ";s=tt";
    }
    
    if ( TRUE==$asHyperref ) {
      $link = " <a href=\"$link\" target=\"_blank\">(";
      $link .= $this->importTypes[$this->importType] .": $id";
      if($cat != 'Titel') { $link .= ' - ' . $cat; }
      $link .= ")</a>";
    }   
    return $link;
  }
    
    
  function printImportID( &$myVar ) {
    $var = array();
    $var = $myVar->getRequest($var,TRUE); 
    
    echo "<form method=\"get\" name=\"importID\" action=\"{$_SERVER['PHP_SELF']}\">";
    echo "<p>";
    echo $var;
    echo "</p>";
    echo "<p>";
    
    echo "<select style=\"margin: 0; padding: 0; vertical-align:middle\" name=\"importDB\">";
    for ( $i=0; $i<count($this->importTypes); ++$i ) {
      echo "<option value=\"$i\" ";
      if ( array_key_exists("importDB", $_GET) && $_GET['importDB'] == $i )
        echo "selected=\"selected\"";
      echo ">{$this->importTypes[$i]}</option>";
    }
    echo "</select>";
    
    echo "<input type=\"text\" style=\"margin: 0; padding: 0; width: 8em; vertical-align:middle\" name=\"importID\" value=\"";
    if ( array_key_exists("importID", $_GET) )
      echo $_GET['importID'];
    echo "\" />";
    echo "<input type=\"submit\" class=\"buttonSubmit\" style=\"vertical-align:middle\" name=\"sent\" value=\"ID importieren\" />";
    echo "</p>";
    echo "</form>";
  }
  
  function printSearch( &$myVar ) {
    $var = array();
    $var = $myVar->getRequest($var,TRUE); 
    
    echo "<form method=\"get\" name=\"search\" action=\"{$_SERVER['PHP_SELF']}\">";
    echo "<p>";
    echo $var;
    echo "</p>";
    echo "<p>";
    
    echo "<select style=\"margin: 0; padding: 0; vertical-align:middle\" name=\"importDB\">";
    for ( $i=0; $i<count($this->importTypes); ++$i ) {
      echo "<option value=\"$i\" ";
      if ( array_key_exists("importDB", $_GET) && $_GET['importDB'] == $i )
        echo "selected=\"selected\"";
      echo ">{$this->importTypes[$i]}</option>";
    }
    echo "</select>";
    
    echo "<input type=\"text\" style=\"margin: 0; padding: 0; width: 8em; vertical-align:middle\" name=\"searchText\" value=\"";
    if ( array_key_exists("searchText", $_GET) )
      echo $_GET['searchText'];
    echo "\" />";
    echo "<input type=\"submit\" class=\"buttonSubmit\" style=\"vertical-align:middle\" name=\"sent\" value=\"Film suchen\" />";
    echo "</p>";
    echo "</form>";
  }
  
  function printSearchEAN( &$myVar ) {
    $var = array();
    $var = $myVar->getRequest($var,TRUE); 
    
    echo "<form method=\"get\" name=\"searchEAN\" action=\"{$_SERVER['PHP_SELF']}\">";
    echo "<p>";
    echo $var;
    echo "</p>";
    echo "<p>";
    
    echo "<select style=\"margin: 0; padding: 0; vertical-align:middle\" name=\"importDB\">";
    for ( $i=0; $i<count($this->importTypes); ++$i ) {
      if ($this->importTypes[$i] == 'OFDB') {
        echo "<option value=\"$i\" ";
        if ( array_key_exists("importDB", $_GET) && $_GET['importDB'] == $i )
          echo "selected=\"selected\"";
        echo ">{$this->importTypes[$i]}</option>";
      }
    }
    echo "</select>";
    
    echo "<input type=\"text\" style=\"margin: 0; padding: 0; width: 8em; vertical-align:middle\" name=\"searchEANText\" value=\"";
    if ( array_key_exists("searchEANText", $_GET) )
      echo $_GET['searchEANText'];
    echo "\" />";
    echo "<input type=\"submit\" class=\"buttonSubmit\" style=\"vertical-align:middle\" name=\"sent\" value=\"EAN importieren\" />";
    echo "</p>";
    echo "</form>";
  }
  
  
  function isGenre( $genre ) {
    $ret = FALSE;
    
    if ( is_array($this->varToImport['genres']) ) {
      if ( in_array( $genre, $this->varToImport['genres'] ) )
        $ret = TRUE;
    }
    return $ret;
  }
  
  function loadFile( $url, &$buf ) {
    $buf = "";
    
    require_once('./classes/class.HttpRequest.php');
    $request = new HTTPRequest($url);
    $buf = $request->DownloadToString();
    
    return strlen($buf);
  }
}

?>
