<?php

/*******************************************
 *                                         *
 *     Filmverwaltung mit PHP & MySQL      *
 *                                         *
 *******************************************
 *                                         *
 * Copyright: ab 2005 Dominik Erdmann      *
 *  Internet: www.der-domi.de              *
 *     Email: kontakt@der-domi.de          *
 *                                         *
 *******************************************
 *                                         *
 * Das Skript darf nach eigenem Belieben   *
 * gendert werden. Copyright-Hinweise und *
 * Links auf www.der-domi.de drfen nicht  *
 * verndert werden und mssen jederzeit   *
 * sichtbar bleiben!                       *
 *                                         *
 *******************************************
 */

/*
 * alles, was mit suchen zu tun hat
 */


if ( $_SESSION['UserRechte'] < 300 )
    exit();


// Suchen-Menu
if ( $myVar->MenuID == 290 )
{

    // Falls Sortiertitel, dann andere Standardsortierung    
    if ($settings->activateSortierTitel)
      $titel = 'Sortiertitel';
    else
      $titel = 'Titel';
  
  
    // alle Filme eines Schauspielers ausgeben
    if ( $myVar->ActorID && !isset($_GET['formular']) )
    {
        if ( $myVar->anzIndividuen >= 1 )
        {
            $beginOutput = ($myVar->page - 1) * $myVar->maxShow;
            
            $sql = "SELECT FilmID, CONCAT( COLLECT_CollectID, '-', LPAD( myFilmID, $settings->anzStellenID, '0' ) ) AS FilmID2, Titel, Originaltitel, Jahr, FSK, FSKunbekannt FROM $myDB->FILME fi INNER JOIN {$prefix}FILME_ACTORS ON FILME_FilmID = FilmID AND ACTORS_ActorID = {$_REQUEST['ActorID']} WHERE $myDB->sqlForPriv $myVar->sqlLetter ";
            
            if ($myVar->orderBy == ausgeliehenAm || $myVar->orderBy == zurueckgegebenAm)
              $sql .= "ORDER BY $titel $myVar->ASC, Titel ASC LIMIT $beginOutput, $myVar->maxShow";
            else
              $sql .= "ORDER BY $myVar->orderBy $myVar->ASC, Titel ASC LIMIT $beginOutput, $myVar->maxShow";
              
            echo "<table id=\"filmTable\">";
            printFilmTableHead( $myVar, $myDB );
            printFilmTable( $sql, $myDB, $settings, $myVar );
            echo "</table>";
        }
    }
    
    // alle Filme eines Regisseurs ausgeben
    else if ( $myVar->RegisseurID && !isset($_GET['formular']) )
    {
        if ( $myVar->anzIndividuen >= 1 )
        {
            $beginOutput = ($myVar->page - 1) * $myVar->maxShow;
            
            $sql = "SELECT FilmID, CONCAT( COLLECT_CollectID, '-', LPAD( myFilmID, $settings->anzStellenID, '0' ) ) AS FilmID2, Titel, Originaltitel, Jahr, FSK, FSKunbekannt FROM $myDB->FILME fi INNER JOIN {$prefix}FILME_REGISSEURE ON FILME_FilmID = FilmID AND REGISSEURE_RegisseurID = {$_REQUEST['RegisseurID']} WHERE $myDB->sqlForPriv $myVar->sqlLetter ";
            
            if ($myVar->orderBy == ausgeliehenAm || $myVar->orderBy == zurueckgegebenAm)
              $sql .= "ORDER BY $titel $myVar->ASC, Titel ASC LIMIT $beginOutput, $myVar->maxShow";
            else
              $sql .= "ORDER BY $myVar->orderBy $myVar->ASC, Titel ASC LIMIT $beginOutput, $myVar->maxShow";
            
            echo "<table id=\"filmTable\">";
            printFilmTableHead( $myVar, $myDB );
            printFilmTable( $sql, $myDB, $settings, $myVar );
            echo "</table>";
        }
    }
    
    // nach einem Schauspieler suchen
    else if ( $myVar->searchIn == "Actors" && strlen($myVar->searchFor) >= 2 && !isset($_GET['formular']) )
    {
        if ( $myVar->anzIndividuen >= 1 )
        {
            $beginOutput = ($myVar->page - 1) * $myVar->maxShow;
            
            $sql2 = "SELECT COUNT(*) AS Anz, ACTORS_ActorID FROM $myDB->FILME_ACTORS fa INNER JOIN $myDB->FILME fi ON fa.FILME_FilmID=fi.FilmID WHERE $myDB->sqlForPriv GROUP BY ACTORS_ActorID";
            $sql = "SELECT Name, ActorID, Anz FROM $myDB->ACTORS a INNER JOIN( $sql2 ) temp ON a.ActorID = temp.ACTORS_ActorID WHERE $myVar->searchVar $myVar->sqlLetterName ORDER BY Name $myVar->ASC LIMIT $beginOutput, $myVar->maxShow";
            
            if ( !$myDB->MySQL_Ver )
                $sql = "SELECT Name, ActorID, COUNT(*) AS Anz FROM $myDB->ACTORS a INNER JOIN $myDB->FILME_ACTORS fa ON a.ActorID = fa.ACTORS_ActorID WHERE $myVar->searchVar $myVar->sqlLetterName GROUP BY a.ActorID ORDER BY Name $myVar->ASC LIMIT $beginOutput, $myVar->maxShow";
            
            echo "<table id=\"filmTable\">";
            printNameHead( $myVar );
            printActorTable( $sql, $myDB, $myVar );
            echo "</table>";
        }
    }
    
    // nach einem Regisseur suchen
    elseif ( $myVar->searchIn == "Regisseure" && strlen($myVar->searchFor) >= 2 && !isset($_GET['formular']) )
    {
        if ( $myVar->anzIndividuen >= 1 )
        {
            $beginOutput = ($myVar->page - 1) * $myVar->maxShow;
            
            $sql2 = "SELECT COUNT(*) AS Anz, REGISSEURE_RegisseurID FROM $myDB->FILME_REGISSEURE fr INNER JOIN $myDB->FILME fi ON fr.FILME_FilmID=fi.FilmID WHERE $myDB->sqlForPriv GROUP BY REGISSEURE_RegisseurID";
            $sql = "SELECT Name, RegisseurID, Anz FROM $myDB->REGISSEURE a INNER JOIN( $sql2 ) temp ON a.RegisseurID = temp.REGISSEURE_RegisseurID WHERE $myVar->searchVar $myVar->sqlLetterName ORDER BY Name $myVar->ASC LIMIT $beginOutput, $myVar->maxShow";
            
            if ( !$MySQL_Ver )
                $sql = "SELECT Name, RegisseurID, COUNT(*) AS Anz FROM $myDB->REGISSEURE r INNER JOIN $myDB->FILME_REGISSEURE fr ON r.RegisseurID = fr.REGISSEURE_RegisseurID WHERE $myVar->searchVar $myVar->sqlLetterName GROUP BY r.RegisseurID ORDER BY Name $myVar->ASC LIMIT $beginOutput, $myVar->maxShow";
            
            echo "<table id=\"filmTable\">";
            printNameHead( $myVar );
            printRegisseurTable( $sql, $myDB, $myVar );
            echo "</table>";
        }
    }
    
    
    // Formular, zum Auswhlen, was gesucht werden soll
    else//if (  $myVar->ActorID == 0 && $myVar->RegisseurID == 0 )
    {
        echo "<form method=\"get\" action=\"{$_SERVER['PHP_SELF']}?\" name=\"search\" >";
        echo "<fieldset>";
        echo "<legend>suchen...</legend>";
            
        $var = array();
        $var['page'] = 1;
        $var['searchFor'] = "";
        $var['searchIn'] = "";
        echo $var = $myVar->getRequest($var,TRUE); 
        
        echo "<select style=\"vertical-align:middle\" name=\"searchIn\" size=\"1\">";
        
        $values = array( array( 'Titel', 'Filmtitel' ), array( 'Actors', 'Schauspieler' ), array( 'Regisseure', 'Regisseure' ), array( 'FilmID', 'FilmID' ) );
        
        for ( $i=0; $i<count($values); ++$i )
        {
            echo "<option value=\"{$values[$i][0]}\" ";
            if ( $values[$i][0] == $myVar->searchIn  )
                echo "selected=\"selected\" style=\"font-weight:bold\"";
            echo ">{$values[$i][1]}</option>";
        }
        
        echo "</select>";
        echo "<input type=\"text\" style=\"vertical-align:middle\" name=\"searchFor\" value=\"$myVar->searchFor\" />";
        echo "<script language=\"javascript\" type=\"text/javascript\">";
        echo "document.search.searchFor.focus(); ";
        echo "document.search.searchFor.select();";
        echo "</script>";
        echo "<input class=\"buttonSubmit\" style=\"vertical-align:middle\" type=\"submit\" value=\"suchen\" />";
        //echo "<input type=\"hidden\" name=\"MenuID\" value=\"290\" />";
        echo "<input type=\"hidden\" name=\"searchFirst\" value=\"\" />";
        
        
        echo "<p>Benutze <strong>*</strong> als Platzhalter! Standardm&auml;&szlig;ig *SUCHWORT*";
        
        if ( $myVar->searchIn && strlen( $myVar->searchFor ) >= 2 )
        {
            $vars = array();
            $vars['page'] = 1;
            $vars['searchFor'] = "";
            $vars['searchIn'] = "";
            $vars = $myVar->getRequest($vars); 
            echo "<span style=\"margin-left:0.5em;font-size:0.9em\"><a href=\"{$_SERVER['PHP_SELF']}?$vars"."formular="."\">(Suche l&ouml;schen)</a></span>";
        }
        echo "</p>";
        echo "</fieldset>";
        echo "</form>";
    }

}




?>
